local name, addon = ...
local embed = addon:LibInit("LibCombatLog", 7, {"RegisterCLEvent", "UnRegisterCLEvent"})
if(type(embed) ~= 'function') then return end
local pairs = pairs
local unpack = unpack
local select = select
local LibCombatLog = LibStub("LibCombatLog")
LibCombatLog['regs'] = LibCombatLog['regs'] or {}
local function combatLog(self,event)
	local data = {CombatLogGetCurrentEventInfo()}
	if(LibCombatLog['regs'][data[2]]) then
		for k, v in pairs(LibCombatLog['regs'][data[2]]) do
			k[v](self,event,unpack(data))
		end
	end
end
LibCombatLog['frame'] = LibCombatLog['frame'] or addon:RegisterFunc({'PLAYER_ENTERING_WORLD'},"OnEvent", function(self,event,arg1)
	self:UnregisterEvent(event)
	self:SetScript("OnEvent", combatLog)
	self:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
end)
local lib = {}
function lib:RegisterCLEvent(event,funcName)
  if(type(event) ~= "string" and funcName) then
	funcName = funcName or event[1]
	for _,v in pairs(event) do
	  LibCombatLog['regs'][v] = LibCombatLog['regs'][v] or {}
	  LibCombatLog['regs'][v][self] = funcName
	end
  else
	funcName = funcName or event
	LibCombatLog['regs'][event] = LibCombatLog['regs'][event] or {}
	LibCombatLog['regs'][event][self] = funcName
  end
end
function lib:UnRegisterCLEvent(event)
  if(LibCombatLog['regs'][event]) then
	if(LibCombatLog['regs'][event][self]) then
	  LibCombatLog['regs'][event][self] = nil
	end
  end
end
embed(lib)
